<?php

	/*
		@name: Payment paybylink.pl
		@last_update: 16/02/2020
		@verstion: 2.00
	*/

	function paybylink_config()
	{
		$array = array(
			"FriendlyName" => array(
				"Type" => "System",
				"Value" => "(Paybylink.pl) Przelew online / BLIK",
				"Size" => "20"
			),
			"shopid" => array(
				"FriendlyName" => "ID sklepu",
				"Type" => "text",
				"Size" => "20"
			),
			"hash" => array(
				"FriendlyName" => "Tajny klucz do sklepu",
				"Type" => "password",
				"Size" => "150"
			),
		);
		return $array;
	}

	function paybylink_link($params)
	{

		if(isset($_POST['paybylinkPay'])) {

			$shopId 			= intval($params['shopid']);
			$description		= strval($params['description']);
			$setEmail			= strval($params['clientdetails']['email']);
			$control 			= strval($params['invoiceid']);
			$price  			= floatval($params['amount']);
			$notifyURL 			= strval($params['systemurl'] . '/modules/gateways/callback/paybylink.php');
			$returnUrlSuccess 	= strval($params['systemurl'] . '/viewinvoice.php?id=' . $params['invoiceid']);
			$signature			= strval('123dsf3r');

	        $data   = $params['hash'] . "|" . $shopId . "|" . sprintf("%.2f", $price);

	        if ($control != null && $control != "") {
	            $data .= "|" . $control;
	        }

	        if ($description != null && $description != "") {
	            $data .= "|" . $description;
	        }

	        if ($email != null && $email != "") {
	            $data .= "|" . $email;
	        }

	        if ($notifyURL != null && $notifyURL != "") {
	            $data .= "|" . $notifyURL;
	        }

	        if ($returnUrlSuccess != null && $returnUrlSuccess != "") {
	            $data .= "|" . $returnUrlSuccess;
	        }

	        print_r($data);
	        $signature = hash('sha256', $data);

			$paybylinkData	= [
				'shopId'            => $shopId,
	            'price'             => $price,
	            'control'           => $control,
	            'description'       => $description,
	            'email'             => $email,
	            'notifyURL'         => $notifyURL,
	            'returnUrlSuccess'  => $returnUrlSuccess,
	            'signature'         => $signature
			];

			$data_string = json_encode($paybylinkData);                                                                                   
			                                                                                                                     
			$ch = curl_init('https://secure.pbl.pl/api/v1/transfer/generate');                                                                      
			curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "POST");                                                                     
			curl_setopt($ch, CURLOPT_POSTFIELDS, $data_string);                                                                  
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);                                                                      
			curl_setopt($ch, CURLOPT_HTTPHEADER, array(                                                                          
			    'Content-Type: application/json',                                                                                
			    'Content-Length: ' . strlen($data_string))                                                                       
			);     

			$result = curl_exec($ch);
			$result = json_decode($result);

			header('Location: https://secure.pbl.pl/transfer/' . $result->transactionId);

		}

		$form_html = '<form method="post">
			<input type="submit" class="button" value="Przejdź do płatności" />
			<input type="hidden" name="paybylinkPay" value="true" />
		</form>';

		return $form_html;
	}


?>